/*
    This file is part of siteNavBar
    Copyright (C) 2005 - 2008  Dr. Klaus Bolwin (webmaster@bolwin.com)

    siteNavBar is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

window.addEventListener("load", function() {init(); }, false);
window.addEventListener("unload", function() {exit(); }, false);

var content = top.window.document.getElementById("content");
content.addEventListener("pageshow", refresh, true);
content.addEventListener("select", refresh, true);

function init()
         {
         document.getElementById("snb_root").addEventListener("click", lade, false);
         var linkel = new Array;
         var sDoc = window.top.window.content.document;
         var as = sDoc.getElementsByTagName("a");
         var links = sDoc.getElementsByTagName("link");
         var area = sDoc.getElementsByTagName("area");
         var tsep1 = document.createElement("treeseparator");
         var tsep2 = document.createElement("treeseparator");
         if(links.length > 0)
                 {
                 kb_sb.constBaum(links);
                 document.getElementById("kb_sb").appendChild(tsep1);
                 }
         if(as.length > 0)
                 {
                 kb_sb.constBaum(as);
                 document.getElementById("kb_sb").appendChild(tsep2);
                 }
         if(area.length > 0) kb_sb.constBaum(area);
         }

function exit()
         {
         content.removeEventListener("pageshow", refresh, true);
         content.removeEventListener("select", refresh, true);
         }

function refresh()
         {
         if(!document) return;
         langel = document.getElementById("kb_sb")
         while (langel && langel.firstChild)
                 {
                 langel.removeChild(langel.firstChild);
                 }
        init();
        }

function lade(e)
         {
         x = e.originalTarget.parentNode;
         if(!x.view) return
         var reihe = x.view.getItemAtIndex(x.currentIndex);
         var datei = reihe.firstChild.childNodes[1].getAttribute("label");
         if (datei != "") content.contentWindow.location.href = datei;
         }



var kb_sb = {

constBaum: function(linkEl)
         {
         for (var i=0; i<linkEl.length; i ++)
                 {
                 var titem = document.createElement("treeitem");
                 var trow = document.createElement("treerow");
                 var tcell1 = document.createElement("treecell");
                 var tcell2 = document.createElement("treecell");
                 var tcell3 = document.createElement("treecell");
                 var tcell4 = document.createElement("treecell");

                 nText = kb_sb.getNText(linkEl[i]);

                 if(nText && nText.length == 0) tcell1.setAttribute("label", altText);
                 else tcell1.setAttribute("label", nText);
                 if(tcell1.getAttribute("label") == "") continue;
                 trow.appendChild(tcell1);
                 tcell2.setAttribute("label", linkEl[i].href);
                 trow.appendChild(tcell2);
                 tcell3.setAttribute("label", linkEl[i].title);
                 trow.appendChild(tcell3);
                 rellink = linkEl[i].rel;
                 if(!rellink) lellink = linkEl[i].rev;
                 tcell4.setAttribute("label", rellink);
                 trow.appendChild(tcell4);
                 titem.appendChild(trow);
                 document.getElementById("kb_sb").appendChild(titem);
                 }

         },

getNText: function(lEl)
         {
         if(lEl.nodeName.toLowerCase() == "area") var nText = lEl.alt;
         else if(lEl.nodeName.toLowerCase() == "link")
                 {
                 var nText = lEl.title;
                 if(nText == "") nText = lEl.rel;
                 }
         else if(lEl.firstChild) var nText = lEl.firstChild.nodeValue;
         while(nText && nText.charCodeAt(0) < 33)
                 {
                 nText = nText.substr(1);
                 }
         if(nText && nText.length == 0)
                 {
                 var altText = "";
                 var asch = lEl.childNodes;
                 for(var j=0; j<asch.length; j++)
                         {
                         if(asch[j].nodeName.toLowerCase() != "img") continue;
                         altText = asch[j].alt;
                         while(altText && altText.charCodeAt(0) < 33)
                                 {
                                 altText = altText.substr(1);
                                 }
                         //if(altText == "" && asch[j].title) altText = asch[j].title;
                         break;
                         }
                 }
         return nText;
         }

}