/*
    This file is part of siteNavBar
    Copyright (C) 2005 - 2009  Dr. Klaus Bolwin (webmaster@bolwin.com)

    siteNavBar is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

window.addEventListener("load", function() {kb_snb.init();}, false);
window.addEventListener("unload", function() {kb_snb.shutdown();}, false);

var kb_snb = {
         prefs: null,

         bocom:null,
         customize:null,
         daColor:"#3333FF",
         daWarn:false,
         darstellungChanged:false,
         doc:null,
         FFversion:null,
         hasrels:false,
         jvsNo:false,
         jvsWarn:false,
         jvsColor:"#3333FF",
         menuVerschoben:false,
         obenUnten:false,
         prefix:new Array("snb-","link-","dlink-"),
         showlang:null,
         showmedia:null,
         showOpt:null,
         showmtype:null,
         showziel:null,
         style:null,
         topMenu:new Array("snb-Toolmenu-top","snb-Toolmenu-sub"),
         wo:null,
         wonicht:null,
         wtPref:null,

         init: function()
                 {
                 this.promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                .getService(Components.interfaces.nsIPromptService);

                 kb_Toolbar = document.getElementById("snb-Toolbar");
                 kb_ferramenta = document.getElementById("snb_statuspane");

                 // Service und Observer fr nderungen der Preferences anmelden

                 this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService)
                                .getBranch("kb_snb.");
                 this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
                 this.prefs.addObserver("", this, false);

                 //this.prefs.lockPref("defaultSet", "snb-start,snb-up,separator,snb-first,snb-prev,snb-next,snb-last,separator,snb-document-menu,snb-more-menu,separator,snb-tag");

                 this.showOpt = this.prefs.getIntPref("wannZeigen");
                 this.wtPref = this.prefs.getBoolPref("wtPref");
                 this.style = this.prefs.getBoolPref("showStyles");
                 this.showmedia = this.prefs.getBoolPref("showMedia");
                 this.showlang = this.prefs.getBoolPref("showLingua");
                 this.showziel = this.prefs.getBoolPref("showZiel");
                 this.showmtype = this.prefs.getBoolPref("showType");
                 this.jvsNo = this.prefs.getIntPref("jvEn");
                 this.jvsWarn = this.prefs.getBoolPref("jvWarn");
                 this.jvsColor = this.prefs.getCharPref("jvColor");
                 this.daWarn = this.prefs.getBoolPref("daWarn");
                 this.daColor = this.prefs.getCharPref("daColor");
                 this.customize = this.prefs.getIntPref("isCustomizable") == 1;
                 this.wo = this.topMenu[this.prefs.getIntPref("menuTopSub") - 1];
                 this.wonicht = this.topMenu[1 - (this.prefs.getIntPref("menuTopSub") - 1)];

                 this.prefg = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService)
                                .getBranch("general.");

                 this.FFversion = this.prefg.getCharPref("useragent.extra.firefox");
                 this.FFversion = parseFloat(this.FFversion.substr(this.FFversion.indexOf("/")+1,3));

                 this.prefi = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService)
                                .getBranch("kb_intPref.");

                 this.prefb = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService)
                                .getBranch("browser.");
                 this.prefb.QueryInterface(Components.interfaces.nsIPrefBranch2);
                 this.prefb.addObserver("", this, false);

                 this.tabWin = (this.prefb.getIntPref("link.open_newwindow") == 2)? "window":"tab";

                 this.setOpt();

                 // Die folgenden beiden Zeilen sind ein work-around fr einen FF3.1b3 bug !!!!!
                 kb_Toolbar.currentSet = kb_Toolbar.getAttribute("defaultset");
                 kb_Toolbar.currentSet = "snb-start,snb-up,separator,snb-first,snb-prev,snb-next,snb-last,separator,snb-chapter-menu,snb-section-menu,snb-subsection-menu,separator,snb-bookmark-menu,snb-appendix-menu,snb-alternate-menu,separator,snb-rest-menu,separator,snb-tag";
                 kb_Toolbar.currentSet = kb_snb.prefs.getCharPref("currentSet");   // sonst luft nichts in der Statusbar
                 kb_Toolbar.setAttribute("currentset", kb_snb.prefs.getCharPref("currentSet"));   // sonst luft nichts in der Statusbar
                 // ________________________________________________________________________________
                  if(!document.getElementById("snb_statuspane").hasChildNodes() && kb_snb.prefs.getIntPref("ondeMonstrar") == 2)
                         {
                         kb_snb.setStatElements(1);          // klont Elemente in die Statusbar
                         }    /*   */
                 if(!document.getElementById(kb_snb.wo).hasChildNodes() && kb_snb.prefs.getIntPref("ondeMonstrar") == 3)
                         {
                         kb_snb.setExtraElements();          // klont Elemente im Extra-Men
                         }

                 kb_Toolbar.setAttribute("mode", "full");        // erzwingt Anzeige von Icons und Text in der snb-Leiste
                 kb_bPopup = document.getElementById("kb_button_menu");

                 var content = document.getElementById("content");
                 content.addEventListener("select", this.onSelectTab, false);
                 // hier keinen load event-handler laden, dies fhrt zu Problemen, stattdessen pageshow
                 content.addEventListener("pageshow", this.onPageLoad, false);

                 kb_Toolbar.addEventListener("mouseover", kb_snb.mOver, false);
                 kb_Toolbar.addEventListener("popupshowing", kb_snb.popupShow, false);

                 myBundle = document.getElementById("snbBundle");
                 },

         shutdown: function()                        // Observer abmelden und prefs speichern
                {
                 //        notwendig, wenn Werte durch toolbarpopup gendert wurden
                 if(kb_Toolbar.collapsed && kb_snb.showOpt < 3 && kb_snb.sichtbar("html", true))
                         this.prefs.setIntPref("wannZeigen", 3);
                 else if (!kb_Toolbar.collapsed && kb_snb.showOpt == 3)
                         this.prefs.setIntPref("wannZeigen", 1);

                 //___________________________________________________________________
                 this.prefs.removeObserver("", this);
                 this.prefb.removeObserver("", this);
                 },

         observe: function(subject, topic, data)    // Aufruf bei Events auf den Preferences
                 {
                 if (topic != "nsPref:changed")
                         {
                         return;
                         }

                 switch(data)
                        {
                        case "link.open_newwindow":
                                 this.tabWin = (this.prefb.getIntPref(data) == 2)? "window":"tab";
                                 break;
                        case "wannZeigen":
                                 this.showOpt = this.prefs.getIntPref(data);
                                 break;
                        case "wtPref":
                                 this.wtPref = this.prefs.getBoolPref(data);
                                 break;
                        case "showStyles":
                                 this.style = this.prefs.getBoolPref(data);
                                 break;
                        case "showMedia":
                                 this.showmedia = this.prefs.getBoolPref(data);
                                 break;
                        case "showLingua":
                                 this.showlang = this.prefs.getBoolPref(data);
                                 break;
                        case "showZiel":
                                 this.showziel = this.prefs.getBoolPref(data);
                                 break;
                        case "showType":
                                 this.showmtype = this.prefs.getBoolPref(data);
                                 break;
                        case "jvEn":
                                 this.jvsNo = this.prefs.getIntPref(data);
                                 break;
                        case "jvWarn":
                                 this.jvsWarn = this.prefs.getBoolPref(data);
                                 break;
                        case "daWarn":
                                 this.daWarn = this.prefs.getBoolPref(data);
                                 break;
                        case "jvColor":
                                 this.jvsColor = this.prefs.getCharPref(data);
                                 break;
                        case "daColor":
                                 this.daColor = this.prefs.getCharPref(data);
                                 break;
                        case "isCustomizable":
                                 this.customize = this.prefs.getIntPref(data) == 1;
                                 break;
                        case "ondeMonstrar":
                                 // Die folgenden beiden Zeilen sind ein work-around fr einen FF3.1b3 bug !!!!!
                                 kb_Toolbar.currentSet = kb_Toolbar.getAttribute("defaultset");
                                 kb_Toolbar.currentSet = "snb-start,snb-up,separator,snb-first,snb-prev,snb-next,snb-last,separator,snb-chapter-menu,snb-section-menu,snb-subsection-menu,separator,snb-bookmark-menu,snb-appendix-menu,snb-alternate-menu,separator,snb-rest-menu,separator,snb-tag";
                                 kb_Toolbar.setAttribute("currentset", kb_snb.prefs.getCharPref("currentSet"));
                                 kb_Toolbar.currentSet = kb_Toolbar.getAttribute("currentset");
                                 this.obenUnten = true;
                                 break;
                        case "currentSet":
                                 switch(kb_snb.prefi.getIntPref("isClassic"))
                                         {
                                         case 0:
                                                 kb_snb.prefs.setCharPref("defSet1", kb_snb.prefs.getCharPref("currentSet"));
                                                 break;
                                         case 1:
                                                 kb_snb.prefs.setCharPref("defSet2", kb_snb.prefs.getCharPref("currentSet"));
                                                 break;
                                         case 2:
                                                 kb_snb.prefs.setCharPref("defSet3", kb_snb.prefs.getCharPref("currentSet"));
                                                 break;
                                         }
                                 // Die folgenden beiden Zeilen sind ein work-around fr einen FF3.1b3 bug !!!!!
                                 kb_Toolbar.currentSet = kb_Toolbar.getAttribute("defaultset");
                                 kb_Toolbar.currentSet = "snb-start,snb-up,separator,snb-first,snb-prev,snb-next,snb-last,separator,snb-chapter-menu,snb-section-menu,snb-subsection-menu,separator,snb-bookmark-menu,snb-appendix-menu,snb-alternate-menu,separator,snb-rest-menu,separator,snb-tag";
                                 kb_Toolbar.currentSet = this.prefs.getCharPref("currentSet");
                                 kb_Toolbar.setAttribute("currentset", kb_snb.prefs.getCharPref("currentSet"));
                                 this.darstellungChanged = true;
                                 break;
                        case "menuTopSub":
                                 this.menuVerschoben = true;
                                 this.wo = this.topMenu[this.prefs.getIntPref("menuTopSub") - 1];
                                 this.wonicht = this.topMenu[1 - (this.prefs.getIntPref("menuTopSub") - 1)];
                                 break;
                        }
                 this.setOpt();

                 },

         disableButtons: function()
                 {
                 var tbb = document.getElementsByTagName("toolbarbutton");
                 for (var i=0; i<tbb.length-1; i++)
                         {
                         if(tbb[i].id.indexOf("snb-") == -1) continue;
                         tbb[i].setAttribute("disabled", true);
                         tbb[i].removeAttribute("tooltiptext");
                         tbb[i].removeAttribute("style");
                         tbb[i].removeAttribute("context");
                         tbb[i].removeEventListener("command", kb_snb.buttonClick, false);
                         tbb[i].removeEventListener("click", kb_snb.buttonClick, false);
                         tbb[i].removeEventListener("mouseover", kb_snb.showNotification, false);
                         tbb[i].removeEventListener("mouseout", kb_snb.removeNotification, false);
                         if(kb_snb.prefs.getIntPref("ondeMonstrar") == 1) tbb[i].setAttribute("context", "toolbar-context-menu");
                         }
                 var mitems = document.getElementsByTagName("menuitem");
                 for (var i=0; i<mitems.length; i++)
                         {
                         if(mitems[i].id.indexOf("snb-") == -1) continue;
                         mitems[i].setAttribute("disabled", true);
                         mitems[i].removeAttribute("tooltiptext");
                         mitems[i].removeAttribute("style");
                         mitems[i].removeAttribute("context");
                         mitems[i].removeEventListener("command", kb_snb.buttonClick, false);
                         mitems[i].removeEventListener("click", kb_snb.buttonClick, false);
                         mitems[i].removeEventListener("mouseover", kb_snb.showNotification, false);
                         mitems[i].removeEventListener("mouseout", kb_snb.removeNotification, false);
                         }
                 var men1 = document.getElementsByTagName("menu");
                 for (var i=0; i<men1.length; i++)
                         {
                         if(men1[i].id.indexOf("snb-") == -1 || kb_snb.signifikanz(men1[i].id) == "-Toolmenu") continue;
                         if(kb_snb.signifikanz(men1[i].id) != "snb")       // snb ist der Rckgabewert, wenn nur ein Bindestrich gefunden wird
                                 {
                                 men1[i].setAttribute("disabled", true);
                                 continue;
                                 }
                         var hcn = men1[i].firstChild.hasChildNodes();
                         if(hcn)
                                 {
                                 kb_snb.removMenu(men1[i].firstChild)
                                 }
                         }
                 var men2 = document.getElementsByTagName("toolbarbutton");
                 for (var i=0; i<men2.length; i++)
                         {
                         if(men2[i].id.indexOf("snb-") == -1) continue;
                         var umenu = men2[i].getElementsByTagName("menu");
                         if(men2[i].type != "menu" || umenu.length != 0) continue;
                         var hcn = men2[i].firstChild.hasChildNodes();
                         if(hcn && men2[i].firstChild.firstChild.hasAttribute("id")) continue;
                         if(hcn)
                                 {
                                 kb_snb.removMenu(men2[i].firstChild)
                                 }
                         }
                 },

         setStatElements: function(no)
                 {
                 var mutter = document.getElementById("snb_statuspane");
                 mutter.setAttribute("context", "kb_snb_menu");
                 sb_elements = kb_snb.prefs.getCharPref("currentSet").split(",");

                 for(var i=0; i<sb_elements.length; i++)
                         {
                         if(sb_elements[i] == "separator") continue;
                         if(!document.getElementById(sb_elements[i])) continue;
                         kind = document.getElementById(sb_elements[i]).cloneNode(true);
                         kind.setAttribute("label", "");
                         mutter.appendChild(kind);
                         }
                 },

         setExtraElements: function()
                 {
                 var mutter = document.getElementById(kb_snb.wo);
                 mutter.setAttribute("collapsed", false);
                 if(mutter.firstChild) mutter.removeChild(mutter.firstChild);

                 // Die folgenden beiden Zeilen sind ein work-around fr einen FF3.1b3 bug!!!!!  Die 4 Zeilen werden bentigt fr den Wechsel des Mens von der Menbar in das Extra-Men und vice versa!!!
                 kb_Toolbar.currentSet = kb_Toolbar.getAttribute("defaultset");
                 kb_Toolbar.currentSet = "snb-start,snb-up,separator,snb-first,snb-prev,snb-next,snb-last,separator,snb-chapter-menu,snb-section-menu,snb-subsection-menu,separator,snb-bookmark-menu,snb-appendix-menu,snb-alternate-menu,separator,snb-rest-menu,separator,snb-tag";
                 kb_Toolbar.currentSet = kb_snb.prefs.getCharPref("currentSet");   // sonst luft nichts in der Statusbar
                 kb_Toolbar.setAttribute("currentset", kb_snb.prefs.getCharPref("currentSet"));   // sonst luft nichts in der Statusbar

                 kind = document.createElement("menupopup");

                 var ende = (kb_snb.prefi.getIntPref("isClassic") == 2)? 13:7;
                 sb_elements = kb_snb.prefs.getCharPref("currentSet").split(",");

                 for(var i=0; i<ende; i++)
                         {
                         if(sb_elements[i] == "separator") continue;
                         enkel = document.createElement("menuitem");
                         neto = document.getElementById(sb_elements[i]).getAttribute("label");
                         netocl = document.getElementById(sb_elements[i]).getAttribute("class");
                         enkel.setAttribute("id", sb_elements[i]);
                         enkel.setAttribute("label", neto);
                         enkel.setAttribute("class", netocl);
                         kind.appendChild(enkel);
                         }

                 var ext = "-popup";
                 for(var i=ende+1; i<sb_elements.length; i++)
                         {
                         did = sb_elements[i]+ext;
                         if(!document.getElementById(did))
                                 {
                                 did = "dlink"+kb_snb.signifikanz(sb_elements[i]);
                                 if(!document.getElementById(did))
                                         did = "clink"+kb_snb.signifikanz(sb_elements[i]);
                                 if(!document.getElementById(did))
                                         continue;
                                 }
                         enkel = document.createElement("menu");
                         stiefkind = document.getElementById(did);
                         urenkel = stiefkind.cloneNode(true);
                         urenkel.setAttribute("id", urenkel.getAttribute("id"));
                         neto = document.createAttribute("label");
                         neto.value = stiefkind.parentNode.label;
                         enkel.setAttributeNode(neto);
                         enkel.appendChild(urenkel);
                         enkel.setAttribute("class", "menu-iconic all-menu");
                         enkel.setAttribute("disabled", true);
                         enkel.setAttribute("id", "snb"+kb_snb.signifikanz(sb_elements[i])+"-menu");
                         kind.appendChild(enkel);
                         }
                 mutter.appendChild(kind);
                 mutter.setAttribute("context", "kb_snb_menu");

                 kb_Toolbar.setAttribute("collapsed", kb_snb.sichtbar("html", true));
                 kb_Toolbar.currentSet = "__empty";             // nicht entfernen
                 kb_Toolbar.setAttribute("currentset", "__empty");
                 },

         signifikanz: function(zk)
                 {
                 i1 = zk.indexOf("-");
                 i2 = zk.indexOf("-", i1+1);
                 return zk.substring(i1, i2);
                 },

         onPageLoad: function(e)
                 {
                 // sortiert alle unntigen pageshow-events aus, lt nur die aus aktivem Tab durch.
                 // Eventbehandlung findet in kb_snb.onSelectTab statt!
                 try{e.originalTarget}
                 catch(er){return}
                 if(e.originalTarget.location.href == "about:blank") return;
                 if(e.originalTarget.defaultView.parent.location.href != window.content.window.location.href) return;
                 kb_snb.onSelectTab();
                 },

         onSelectTab: function(ereignis)
                 {
                 try{selection = ereignis.originalTarget}
                 catch(e)
                         {
                         // wenn kein Ereignis bermittelt wurde.
                         contentKinder = document.getAnonymousNodes(document.getElementById("content"));
                         panels = contentKinder[1].getElementsByTagNameNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "tabpanels");
                         selection = panels[0];
                         }

                 if(selection.nodeName != "xul:tabpanels") return false;

                 document.getElementById("snb-Toolbar").setAttribute("mode", kb_snb.prefs.getCharPref('icStyle'));
                 kb_snb.hasrels = false;
                 kb_snb.disableButtons();

                 var selTab = selection.selectedIndex;
                 if(selection.childNodes[selTab])
                         var selDoc = selection.childNodes[selTab].firstChild;
                 docWin = selDoc.contentWindow;
                 //********************************************
                 if(kb_snb.FFversion >= 3.1)
                         {
                         // es muessen alle notifications (aller Tabs) entfernt werden, sonst gibt es Probleme mit
                         // der Preference Dialogbox (keine Aktualisierung der SideNavBar).
                         /*
                         for(i=0; i<selection.childNodes.length; i++)
                                 {
                                 nWin = selection.childNodes[i].firstChild.contentWindow;
                                 nBox = window.getNotificationBox(nWin);
                                 nBox.removeAllNotifications(false);
                                 }
                         */
                         notifyBox = window.getNotificationBox(docWin);
                         }
                 var sdContent = selDoc.contentDocument;
                 var docel = sdContent.documentElement.nodeName;
                 kb_snb.doc = sdContent;
                 var areFrames = sdContent.getElementsByTagName('frame');
                 // ************************ wenn ein Frameset geladen wurde:  ********************************
                 if(areFrames.length>1)
                         {
                         var links = kb_snb.readFrames(sdContent, "link", areFrames);
                         var as = kb_snb.readFrames(sdContent, "a", areFrames)
                         }
                 else    // *************** kein Frameset *************
                         {
                         var links = sdContent.getElementsByTagName("link");
                         var as = sdContent.getElementsByTagName("a");
                         }
                 kb_snb.setButtonsFromLinks(links);
                 kb_snb.setButtonsFromLinks(as);

                 if(kb_snb.hasrels && kb_snb.showOpt == 3 && kb_snb.prefs.getBoolPref("infOnDisabled"))
                         {
                         var myAlarm = 2;
                         var mybild = "chrome://global/skin/icons/information-24.png";
                         var buttonText = myBundle.getString("buttonText1");
                         var buttons = [{label: buttonText, accessKey: null, popup: "kb_notify_menu", callback: null}];
                         var notifyText = myBundle.getString("foundElementButHiddenBar");
                         notifyBox.appendNotification(notifyText, 7, mybild, myAlarm, buttons);
                         }

                 kb_Toolbar.setAttribute("collapsed", !kb_snb.sichtbar(docel, kb_snb.prefs.getIntPref("ondeMonstrar") != 1));
                 kb_ferramenta.setAttribute("collapsed", !kb_snb.sichtbar(docel, kb_snb.prefs.getIntPref("ondeMonstrar") != 2));
                 document.getElementById(kb_snb.wo).setAttribute("collapsed", !kb_snb.sichtbar(docel, kb_snb.prefs.getIntPref("ondeMonstrar") != 3));
                 if(document.getElementById("snb-tag"))
                         document.getElementById("snb-tag").setAttribute("disabled", false);
                 return true;
                 },

         readFrames: function(tC, nN, aF)         //tC=contentDocument; nN="link"|"a"; aF=Array der Frames
                 {
                 var hArray = new Array;
                 var nNAy = tC.getElementsByTagName(nN);
                 for(var i=0; i<nNAy.length; i++) hArray.push(nNAy[i]);
                 var nNAy = new Array;
                 for(var i=0; i<aF.length; i++)
                         {
                         linksp = new Array;
                         if(aF[i].contentDocument.getElementsByTagName(nN).length > 0)
                                 {
                                 linksp = aF[i].contentDocument.getElementsByTagName(nN);
                                 for(var j=0; j<linksp.length; j++)
                                         {
                                         if(linksp[j].target == "" || linksp[j].target == "_self")
                                                 linksp[j].setAttribute("target", aF[i].name);
                                         nNAy.push(linksp[j]);
                                         }
                                 }
                         }
                 for(var i=0; i<nNAy.length; i++) hArray.push(nNAy[i]);
                 return hArray;
                 },

         sichtbar: function(root, pref_sb)
                 {
                 return !(root.toLowerCase() != "html" || pref_sb || !(kb_snb.showOpt == 1 || (kb_snb.hasrels && kb_snb.showOpt != 3)));
                 },

         /* in FF3.1b2 sind die Palettenelemente bei Wahl der Darstellung in der Statusbar nicht mehr, wie bei
            frheren Versionen an ein Statusbar panel gebunden, sondern weiterhin an die toolbar.
            Deshalb mssen diese Elemente hier gesucht werden.
         */
         getStatusElement: function(id)
                 {
                 mySelection = kb_ferramenta.getElementsByTagName("toolbarbutton");
                 for(var j=0; j<mySelection.length; j++)
                         if(mySelection[j].id == id) return mySelection[j];
                 mySelection = kb_ferramenta.getElementsByTagName("menuitem");
                 for(var j=0; j<mySelection.length; j++)
                         if(mySelection[j].id == id) return mySelection[j];
                 mySelection = kb_ferramenta.getElementsByTagName("menu");
                 for(var j=0; j<mySelection.length; j++)
                         if(mySelection[j].id == id) return mySelection[j];
                 mySelection = kb_ferramenta.getElementsByTagName("menupopup");
                 for(var j=0; j<mySelection.length; j++)
                         if(mySelection[j].id == id) return mySelection[j];
                 },


         setButtonsFromLinks: function(lks)
                 {
                 for (var i=0; i<lks.length; i++)
                         {
                         var l = lks[i];
                         if (l.rel || l.rev)
                                 {
                                 if (l.rel) var rel = kb_snb.normalizeRel(l.rel);
                                 else var rel = kb_snb.normalizeRel(l.rev);

                                 for(var j=0; j<kb_snb.prefix.length; j++)
                                         {
                                         var id = kb_snb.prefix[j] + rel;
                                         myElement = document.getElementById(id);
                                         if(this.prefs.getIntPref("ondeMonstrar") == 2)
                                                 {
                                                 myElement = kb_snb.getStatusElement(id);
                                                 }
                                         // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                         if(myElement)
                                                 {
                                                 //if(myElement instanceof Components.interfaces.nsIDOMXULPopupElement)    // funktioniert im FF3.1b3 nicht, jedoch in frheren Versionen
                                                 if(myElement.nodeName == "menupopup")
                                                         {
                                                         kb_snb.constrMenu(myElement, l);   //myElement kann nur menupopup sein
                                                         document.getElementById(id).parentNode.setAttribute("disabled", false);
                                                         uroma = myElement.parentNode.parentNode.parentNode ;
                                                         if(uroma) uroma.setAttribute("disabled", false);
                                                         }
                                                 else
                                                         kb_snb.initButton(myElement, l);   //myElement kann toolbarbutton/menuitem/menu sein!
                                                 }
                                         }
                                }
                         }
                 },

         initButton: function(button, l)
                 {
                 try {urlSecurityCheck(l.href, l.ownerDocument.nodePrincipal, kb_snb.jvsNo);}
                 catch(ex) {return;}

                 if(l) button.___link = l;
                 /* ~~~~~~~~~~~~~ Eventhandler ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 ACHTUNG!         var newEvent = new Function(ocl); in Verbindung mit
                 addEventListener("click", newEvent, false);  erffnet die Mglichkeit, da Code der hhere
                 Privilegien bentigt und deshalb in Webseiten nicht ausgefhrt werden darf, von dort in die
                 Chromeumgebung eingeschleust und ausgefhrt wird, was zu Sicherheitsproblemen fhrt.
                 Mit:
                 addEventListener("click", kb_snb.buttonClick, false);
                 umgeht man dieses Problem, da der Event dann wie ein Javascript-Link behandelt wird. */

                 var ocl = null;
                 ocl = l.getAttribute("onclick");
                 /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  */

                 if(l.href) var href = l.href;
                 else if(l.resource) var href = l.resource;
                 else return;

                 if(l.target == "sidebar" || l.rel == "sidebar") kb_snb.setObserver(button);

                 var MI = kb_snb.moreInfo(l);

                 button.parentNode.parentNode.setAttribute("disabled", false);
                 if(button.parentNode.parentNode.id != "snb-data-menu") kb_snb.hasrels = true;

                 button.setAttribute("disabled", false);
                 if(button.nodeName == "menuitem") button.setAttribute("context", "kb_button_menu");
                 if(button.nodeName != "menu" && button.type != "menu")
                         {
                         if (button.disabled == false) button.setAttribute("context", "kb_button_menu");
                         //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                         if(ocl && kb_snb.prefs.getBoolPref("doOcl")) button.addEventListener("click", kb_snb.buttonClick, false);
                         //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                         button.addEventListener("command", kb_snb.buttonClick, false);
                         if(href.substr(0,11) == "javascript:" || ocl)
                                 {
                                 button.addEventListener("mouseover", kb_snb.showNotification, false);
                                 button.addEventListener("mouseout", kb_snb.removeNotification, false);
                                 }

                         if(button.nodeName == "toolbarbutton" && l.title)
                                 button.setAttribute("tooltiptext", l.title+"     "+MI);
                         else
                                 {
                                 try {button.setAttribute("tooltiptext", decodeURIComponent(href)+"     "+MI);
                                 }
                                 catch(e) {if(l.type) button.setAttribute("tooltiptext", l.type+"     "+MI);}
                                 }
                         }
                 kb_snb.indicate(href, button)
                 if(kb_snb.prefs.getIntPref("ondeMonstrar") == 2 || kb_snb.prefs.getCharPref("icStyle") == "icons")
                         {
                         myTBSel = kb_Toolbar.getElementsByTagName("toolbarbutton");
                         mySBSel = kb_ferramenta.getElementsByTagName("toolbarbutton");
                         for(var j=0; j<mySBSel.length; j++)
                                 if(mySBSel[j].type == "menu") mySBSel[j].setAttribute("tooltiptext", myTBSel[j].label);
                         }
                 },

         wrappJsCode: function(hrf)      //Rckgabewert 'undefined' erzwingen
                 {
                 if(!hrf) return;
                 if(hrf.substr(-1) == ";") hrf = hrf.substr(0, hrf.length-1);
                 var befehle = hrf.split(";");
                 hrf = "javascript:";
                 for(var k=0; k<befehle.length; k++)
                         {
                         if(befehle[k].substr(0,4) != "void")
                                 {
                                 befehle[k] = "void("+befehle[k]+");"
                                 hrf += befehle[k];
                                 }
                         else hrf += befehle[k];
                         }
                 return hrf;
                 },

         buttonClick: function(e)    // myEl.target bercksichtigt das Target-Attribut
                 {
                 try {referrer = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(docWin.location, null, null);}
                 catch(e){referrer = null;}

                 var myEl = e.currentTarget.___link;
                 // wenn myEl undefined, weil event von der Tastatur kommt (e.currentTarget.nodeName == key) dann:
                 if(!myEl) myEl = document.getElementById(e.originalTarget.id.replace(/key/, "snb")).___link;

                 if(!myEl || !myEl.href) return;

                 // e.type = click|command
                 if(e.type == "click" || (e.originalTarget.nodeName == "key" && myEl.getAttribute("onclick")))
                         {
                         var ocl = kb_snb.wrappJsCode(myEl.getAttribute("onclick"));
                         openUILinkIn(ocl, "current");
                         if(e.type == "click") return;
                         }

                 if(myEl.target != "current" && myEl.target != "" && myEl.target != "_self")
                         {
                         try {urlSecurityCheck(myEl.href, myEl.ownerDocument.nodePrincipal, Components.interfaces.nsIScriptSecurityManager.DISALLOW_INHERIT_PRINCIPAL);}
                         catch(ex){kb_snb.promptService.alert(null, myBundle.getString("errorTitle"), ex); return;}
                         }

                 if(myEl.href.substr(0,11) == "javascript:") myEl.href = kb_snb.wrappJsCode(myEl.href.substr(11))

                 if(myEl.rel == "sidebar" || myEl.target == "sidebar")
                         {
                         mySBox = document.getElementById("sidebar-box");
                         mySBox.setAttribute("hidden", false);
                         mySBox.setAttribute("sidebarcommand", "snbSB2");
                         document.getElementById("sidebar-splitter").setAttribute("hidden", false);
                         document.getElementById("sidebar-title").setAttribute("value", myEl.title);
                         document.getElementById("sidebar").contentWindow.location.href = myEl.href;
                         document.getElementById("snbSB2").setAttribute("checked", "true");
                         return;
                         }

                 lZiel = ((myEl.target == "window" || myEl.target == "tab") && kb_snb.wtPref)? "_blank":myEl.target;
                 switch(lZiel)
                         {
                         case "_blank":
                                 openUILinkIn(myEl.href, kb_snb.tabWin, null, null, referrer);     //This function is declared in utilityOverlay.js
                                 break;
                         case "win":
                                 lZiel = "window";
                         case "window":
                         case "tab":
                         case "save":
                         case "tabshifted":
                                 openUILinkIn(myEl.href, lZiel, null, null, referrer);
                                 break;
                         case "current":
                         case "_top":
                         case "_parent":
                         case "_self":
                         case "":
                                 openUILinkIn(myEl.href, "current", null, null, referrer);
                                 break;
                         default:                                             //andere Werte werden als Framenamen interprtiert. Ggf. wurde "_self" in readFrames umgewandelt in den Famenamen.
                                 if(docWin.frames.length == 0)                //docWin wurde in onSelectTab definiert; ansonsten sollte document.getElementById("content").contentWindow funktionieren.
                                         openUILinkIn(myEl.href, "current", null, null, referrer);
                                 else
                                         {
                                         var myFrame = -1;
                                         for(var f=0; f<docWin.frames.length; f++)
                                                 if(docWin.frames[f].name == lZiel) myFrame = f;
                                         if(myFrame != -1)
                                                 void(docWin.frames[myFrame].wrappedJSObject.location.href = myEl.href);     //
                                         }
                         }
                 },

         indicate: function(hrf, lmnt)
                 {
                 if(lmnt.parentNode && lmnt.parentNode.nodeName == "popup") return;
                 if(lmnt.nodeName == "menu" || lmnt.type == "menu") return;
                 var sty = document.createAttribute("style");

                 zuTun = (hrf.indexOf("javascript:") != -1) && kb_snb.jvsWarn || (hrf.indexOf("data:") != -1) && kb_snb.daWarn || lmnt.___link.getAttribute("onclick");
                 if(zuTun)
                         {
                         var deco = "none";
                         var color = (hrf.indexOf("javascript:") != -1)? kb_snb.jvsColor:(hrf.indexOf("data:") != -1)? kb_snb.daColor:kb_snb.jvsColor;
                         if(lmnt.___link.getAttribute("onclick"))
                                 deco = "bold";
                         sty.nodeValue = "color:"+color+"; font-weight:"+deco+";";
                         lmnt.setAttributeNode(sty);
                         }
                 },

         showNotification: function(e)
                 {
                 if(kb_snb.FFversion < 3.1 || !kb_snb.prefs.getBoolPref("jvNotify")) return;
                 //var buttons = [{label: "popupButtonText", popup: "blockedPopupOptions", callback: null}];
                 var myEl = e.currentTarget.___link;
                 var myText = "";
                 if(myEl.href.substr(0,11) == "javascript:") myText += "Javascript-Link: "+decodeURIComponent(myEl.href)+"   ";
                 if(myEl.getAttribute("onclick")) myText += "onclick: "+decodeURIComponent(myEl.getAttribute("onclick"));
                 var myAlarm = 4;
                 var mybild = "chrome://global/skin/icons/information-24.png";
                 if(myText.indexOf("navigator.") != -1 || myText.indexOf("java.") != -1) myAlarm = 7;
                 notifyBox.appendNotification(myText, 6, mybild, myAlarm);
                 },

         removeNotification: function(e)
                 {
                 if(kb_snb.FFversion < 3.1) return;
                 notifyBox.removeAllNotifications(false);
                 },

         setObserver: function(clkEl)
                 {
                 var obs = document.createElement("observes");
                 var ele = document.createAttribute("element");
                 var att = document.createAttribute("attribute");
                 ele.nodeValue = "snbSB2";
                 att.nodeValue = "oncommand";
                 clkEl.appendChild(obs);
                 },

         constrMenu: function(popup, l)
                 {
                 var isAnchor = (l instanceof Components.interfaces.nsIDOMHTMLAnchorElement);
                 if(!l.href && l.rev == "bookmark" && isAnchor && (l.id || l.name)) l.href = kb_snb.constrHREF(l.id, l.name);
                 try {urlSecurityCheck(l.href, l.ownerDocument.nodePrincipal, kb_snb.jvsNo);}
                 catch(ex){return;}

                 var meIt = document.createElement("menuitem");
                 var lab = document.createAttribute("label");
                 var exc = document.createAttribute("acceltext");

                 /* ~~~~~~~~~~~~~ Eventhandler ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 ACHTUNG!         var newEvent = new Function(ocl); in Verbindung mit
                 addEventListener("click", newEvent, false);  erffnet die Mglichkeit, da Code der Chrome
                 Privilegien bentigt und deshalb in Webseiten nicht ausgefhrt werden darf, von dort in die
                 Chromeumgebung eingeschleust und ausgefhrt wird, was zu Sicherheitsproblemen fhrt.
                 Mit:
                 addEventListener("click", kb_snb.buttonClick, false);
                 umgeht man dieses Problem, da der Event dann wie ein Javascript-Link behandelt wird. */

                 var ocl = null;
                 ocl = l.getAttribute("onclick");
                 /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  */

                 if(l.href) {var href = l.href; meIt.___link = l;}
                 else if(l.resource) var href = l.resource;
                 else return;

                 if(l.target == "sidebar" || l.rel == "sidebar") kb_snb.setObserver(meIt);

                 var MI = kb_snb.moreInfo(l);
                 if(MI) exc.nodeValue = MI;
                 if(l.title)
                         lab.nodeValue = l.title;
                 else if(l.rel)
                         lab.nodeValue = l.rel;
                 else
                         lab.nodeValue = l.rev;
                 kb_snb.indicate(href, meIt)

                 meIt.setAttributeNode(lab);
                 meIt.setAttributeNode(exc);
                 try {meIt.setAttribute("tooltiptext", decodeURIComponent(l.href));}
                 catch(e) {meIt.setAttribute("tooltiptext", e);}
                 meIt.setAttribute("class", "menuitem-iconic doc");
                 meIt.setAttribute("context", "kb_button_menu");
                 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 if(ocl && kb_snb.prefs.getBoolPref("doOcl")) meIt.addEventListener("click", kb_snb.buttonClick, false);
                 //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 meIt.addEventListener("command", kb_snb.buttonClick, false);
                 if(href.substr(0,11) == "javascript:" || ocl)
                         {
                         meIt.addEventListener("mouseover", kb_snb.showNotification, false);
                         meIt.addEventListener("mouseout", kb_snb.removeNotification, false);
                         }
                 if(kb_snb.checkObNeu(popup, l.href))
                         {
                         popup.appendChild(meIt);
                         popup.parentNode.setAttribute("disabled", false);
                         }
                 },

         constrHREF: function(myid, myname)          // Erzeugt HREF fr a-Anker mit rev=bookmark Attribut
                 {
                 var anker = null;
                 var rawHREF = window.content.location.pathname;
                 if(myid) anker = "#"+myid;
                 else if(myname) anker = "#"+myname;
                 if(anker != null) return rawHREF+anker;
                 else return null;
                 },

         removMenu: function(men)
                 {
                 for(var i=men.childNodes.length-1; i>=0; i--)
                         {
                         men.removeChild(men.firstChild);
                         }
                 men.parentNode.setAttribute("disabled", true);
                 },

         checkObNeu: function(popup, lh)
                 {
                 if(!lh) return false;
                 if(!popup.hasChildNodes()) return true;
                 for(var i=0; i<popup.childNodes.length; i++)
                         {
                         if(popup.childNodes[i].getAttribute("tooltiptext") == decodeURIComponent(lh)) return false;
                         }
                 return true;
                 },

         normalizeRel: function(rawrel)
                 {
                 rawrel = rawrel.toLowerCase();
                 rawrel = rawrel.match(/^\S*/);
                 switch (rawrel)
                         {
                         case "start":
                         case "top":
                         case "home":
                         case "origin":
                         return "start";

                         case "up":
                         case "parent":
                         return "up";

                         case "begin":
                         case "first":
                         return "first";

                         case "prev":
                         case "previous":
                         return "prev";

                         case "end":
                         case "last":
                         return "last";

                         case "author":
                         case "made":
                         return "author";

                         case "icon":
                         case "shortcut icon":
                         return "icon";

                         case "content":
                         case "contents":
                         case "toc":
                         return "toc";

                         case "stylesheet":
                         case "alternate stylesheet":
                         case "alternative stylesheet":
                         return "style";

                         case "prefetch":
                         return null;

                         default:
                         return rawrel;
                         }
                 },

         getOpt: function()
                 {
                 //        notwendig, wenn Werte durch toolbarpopup gendert wurden
                 if(kb_Toolbar.collapsed && kb_snb.showOpt < 3 && kb_snb.sichtbar("html", true))
                         this.prefs.setIntPref("wannZeigen", 3);
                 else if (!kb_Toolbar.collapsed && kb_snb.showOpt == 3)
                         this.prefs.setIntPref("wannZeigen", 1);

                 notifyBox.removeAllNotifications(false);
                 //____________________________________________________________________
                 window.openDialog("chrome://sitenavbar/content/sitenavpref.xul", "showmore", "chrome,titlebar,toolbar,centerscreen,modal");
                 },

         setOpt: function()
                 {
                 var mutter;
                 document.getElementById(kb_snb.wonicht).setAttribute("collapsed", true);
                 document.getElementById(kb_snb.wo).setAttribute("collapsed", false);

                 kb_Toolbar.setAttribute("customizable", kb_snb.customize);
                 kb_Toolbar.setAttribute("mode", "full");

                 if(!kb_snb.doc)kb_snb.doc = window.content.document;

                 var docel = kb_snb.doc.documentElement.nodeName;
                 // Hier nicht prefs ondeMonstrar bercksichtigen, deshalb 2. Parameter false
                 kb_Toolbar.setAttribute("collapsed", !kb_snb.sichtbar(docel, false));

       // **************** Wechsel zwischen Toolbar und Statusbar ******************************************

                 if(this.obenUnten && this.prefs.getIntPref("ondeMonstrar") != 2 || this.darstellungChanged && this.prefs.getIntPref("ondeMonstrar") == 2)
                         {
                         // entferne alle Elemente aus der Statusbar
                         mutter = document.getElementById("snb_statuspane");
                         while (mutter.firstChild)
                                 {
                                 mutter.removeChild(mutter.firstChild);
                                 }
                         }

                 mutter = (this.menuVerschoben)? document.getElementById(kb_snb.wonicht):document.getElementById(kb_snb.wo);
                 if((this.obenUnten && this.prefs.getIntPref("ondeMonstrar") != 3 || this.menuVerschoben) && mutter.hasChildNodes())
                         {
                         // entferne alle Elemente aus dem Extra-Men
                         mutter.removeChild(mutter.firstChild);
                         mutter.setAttribute("collapsed", true);
                         }

                 // zeige toolbar
                 if(this.obenUnten && this.prefs.getIntPref("ondeMonstrar") == 1)
                         kb_Toolbar.setAttribute("collapsed", !kb_snb.sichtbar(docel, false));

                 if((this.obenUnten || this.darstellungChanged) && this.prefs.getIntPref("ondeMonstrar") == 2)
                         kb_snb.setStatElements(2);   /* */
                 if((this.obenUnten || this.darstellungChanged || this.menuVerschoben) && this.prefs.getIntPref("ondeMonstrar") == 3)
                         kb_snb.setExtraElements();
                 this.obenUnten = false;
                 this.menuVerschoben = false;

       // **************************************************************************************************

                 kb_snb.onSelectTab();

                 if(document.getElementById("snb-style"))document.getElementById("snb-style").collapsed = kb_snb.style;
                 if(document.getElementById("snb-icon"))document.getElementById("snb-icon").collapsed = kb_snb.style;
                 if(document.getElementById("snb-tag"))
                         document.getElementById("snb-tag").setAttribute("disabled", false);
                 },

         moreInfo: function(l)
                 {
                 var moreI = new Array;
                 var mehrI = "";
                 var j = 0;
                 if(l.hreflang && kb_snb.showlang) {moreI[j] = l.hreflang; j++;}
                 if(l.media && kb_snb.showmedia) {moreI[j] = l.media; j++;}
                 if(l.target && kb_snb.showziel) {moreI[j] = l.target; j++;}
                 if(l.type && kb_snb.showmtype) {moreI[j] = l.type; j++;}
                 if(moreI.length == 0) return "";
                 else if(moreI.length == 2) mehrI = moreI[0]+", "+moreI[1];
                 else mehrI = moreI[0];
                 return "["+mehrI+"]";
                 },

         mOver: function(e)
                 {
                 if(e.target instanceof Components.interfaces.nsIDOMXULButtonElement)
                         {
                         if(kb_snb.bocom != null && kb_snb.bocom.open == true && e.target != kb_snb.bocom)
                                 {
                                 kb_bPopup.hidePopup();
                                 kb_snb.bocom.open = false;
                                 e.target.open = true;
                                 }
                         }
                 },

         popupShow: function(e)
                 {
                 if(e.target.parentNode instanceof Components.interfaces.nsIDOMXULButtonElement)
                         {
                         kb_snb.bocom = e.target.parentNode;
                         }
                 },

         handlePUEv: function(clZiel)
                 {
                 try {this.menuItem = document.popupNode; this.link = this.menuItem.___link;}
                 catch(e) {kb_snb.promptService.alert(null, myBundle.getString("errorTitle"), ex); return;}

                 this.openLinkInZiel = function() {kb_snb.loadLink(this.link, clZiel);}
                 this.saveL = function() {kb_snb.saveL(this.link, this.menuItem.getAttribute("label"));}
                 this.copyL = function() {kb_snb.copyL(this.link);}
                 this.showI = function() {kb_snb.showI(this.link);}
                 this.viewsource = function() {kb_snb.viewsource(this.link);}
                 this.sendL = function() {MailIntegration.sendMessage(this.link.href, this.menuItem.getAttribute("label"));}
                 this.addBM = function() {
                                 try {urlSecurityCheck(this.link.href, this.link.ownerDocument.nodePrincipal, Components.interfaces.nsIScriptSecurityManager.DISALLOW_INHERIT_PRINCIPAL);}
                                 catch(ex){kb_snb.promptService.alert(null, myBundle.getString("errorTitle"), ex); return;}
                                 PlacesCommandHook.bookmarkLink(PlacesUtils.bookmarksMenuFolderId, this.link.href, this.menuItem.getAttribute("label"));
                                 }
                 },

         loadLink: function(link, ziel)
                 {
                 try {referrer = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(docWin.location, null, null);}
                 catch(e){referrer = null;}

                 try {urlSecurityCheck(link.href, link.ownerDocument.nodePrincipal, Components.interfaces.nsIScriptSecurityManager.DISALLOW_INHERIT_PRINCIPAL);}
                 catch(ex){kb_snb.promptService.alert(null, myBundle.getString("errorTitle"), ex); return;}
                 if(ziel == "window" || ziel == "save")
                         openUILinkIn(link.href, ziel, null, null, referrer);
                 else
                         {
                         var w = getTopWin();
                         var browser = w.getBrowser();
                         lIB = (ziel == "tab")? false:true;

                         browser.loadOneTab(link.href, referrer, null, null, lIB);
                         }
                 },

         viewsource: function(link)
                 {
                 try {urlSecurityCheck(link.href, link.ownerDocument.nodePrincipal, Components.interfaces.nsIScriptSecurityManager.DISALLOW_INHERIT_PRINCIPAL);}
                 catch(ex){kb_snb.promptService.alert(null, myBundle.getString("errorTitle"), ex); return;}
                 slink = "view-source:"+link.href;

                 var neuesFenster = window.open(slink, "Quelltext", "width=640,height=480,chrome=yes,centerscreen=yes,resizable=yes");
                 neuesFenster.focus();
                 },

         copyL: function(link)
                 {
                 var clipboard = Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
                 clipboard.copyString(link.href);
                 },

         showI: function(link)
                 {
                 this.linkel = link;
                 window.openDialog("chrome://sitenavbar/content/showProp.xul", "showmore", "dialog=yes,modal=no,resizable=no,centerscreen=yes,width=450,height=350");
                 }



}