/*
    This file is part of siteNavBar
    Copyright (C) 2005 - 2009  Dr. Klaus Bolwin (webmaster@bolwin.com)

    siteNavBar is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

window.addEventListener("load", function() {snb_pref.init(); }, false);


var snb_pref = {

         ursprung: null,
         ft:false,      //ACHTUNG! verhindert den Aufruf von selectTyp durch onselect beim Laden des Fensters (wird in init auf true gesetzt)!
         tBars:null,
         tElemente:new Array,
         curRumpf:"snb-start,snb-up,separator,snb-first,snb-prev,snb-next,snb-last,separator",
         curOpera:"snb-start,snb-index,snb-toc,snb-search,snb-glossary,snb-help,snb-first,snb-prev,snb-next,snb-last,snb-up,snb-copyright,snb-author,separator",
         allMenu:"chapter,bookmark,section,appendix,subsection,alternate,rest",

         init: function()
                 {       
                 var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                         .getService(Components.interfaces.nsIWindowMediator);
                 snb_pref.ursprung = wm.getMostRecentWindow("navigator:browser");

                 this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService)
                                .getBranch("kb_snb.");

                 this.prefg = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService)
                                .getBranch("general.");

                 this.prefi = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefService)
                                .getBranch("kb_intPref.");

                 myBundle = snb_pref.ursprung.document.getElementById("snbBundle");

                 if(this.prefg.getCharPref("useragent.extra.firefox") < 3.1) document.getElementById('snb-jv-notify').collapsed = true;
                 uSC = this.prefs.getIntPref("jvEn");
                 uSC = (uSC > 4)? 1:uSC;
                 uSC = (uSC > 2)? 2:uSC;
                 Knoten = document.getElementById("kb_snb_supEv");
                 Mutter = document.documentElement;
                 anNodes = document.getAnonymousNodes(Mutter);
                 anIcon = anNodes[0].firstChild.childNodes[3];
                 document.getElementById('snb-jvs').selectedIndex = uSC;
                 document.getElementById('showss').disabled = !document.getElementById('snb-data-menu').checked;
                 document.getElementById('mlIconStyle').addEventListener("select", function() {snb_pref.prefs.setCharPref('icStyle', this.value);}, false);

                 snb_pref.ft = true;     // siehe Kommentar oben
                 altDIndex = this.prefi.getIntPref("isClassic");
                 lastIndex = altDIndex;
                 document.getElementById('snb-deck1').selectedIndex = altDIndex;
                 try {snb_pref.tBars = snb_pref.ursprung.document.getElementById("navigator-toolbox").getElementsByTagName("toolbar");}
                 catch(e) {}

                 document.getElementById("rdg1_2").disabled = this.prefs.getIntPref("ondeMonstrar")!=3;
                 document.getElementById("iOnD").disabled = this.prefs.getIntPref("wannZeigen")!=3;

                 // disabel those elements, which are on other Toolbars than snb_toolbar
                 var t = snb_pref.tBars;
                 for(i=0; i<t.length; i++)
                        {
                        tEl = t[i].currentSet.split(",");
                        snb_pref.tElemente.push(tEl);
                        if(t[i].id != "snb-Toolbar")
                                 for(j=0; j<tEl.length; j++)
                                         {
                                         if(document.getElementById(tEl[j]))
                                                 {
                                                 document.getElementById(tEl[j]).checked = false;
                                                 document.getElementById(tEl[j]).setAttribute("disabled", true);
                                                 }
                                         }
                        }
                 document.getElementById('rdg3').selectedIndex = altDIndex;
                 snb_pref.selectTyp(altDIndex);

                 try {document.getElementById("lastheader").setAttribute("title", this.prefg.getCharPref('useragent.extra.firefox')+" Add-on");}
                 catch(e) {}

                 },

         reset: function()
                 {
                 document.getElementById('snb-deck1').selectedIndex = 0;
                 document.getElementById('rdg3').selectedIndex = 0;
                 this.prefi.setIntPref("isClassic", 0);

                 document.getElementById("snb-document-menu").checked = true;
                 document.getElementById("snb-more-menu").checked = true;
                 document.getElementById("snb-data-menu").checked =  false;

                 document.getElementById("snb-chapter-menu").checked = false;
                 document.getElementById("snb-bookmark-menu").checked = false;
                 document.getElementById("snb-section-menu").checked = false;
                 document.getElementById("snb-appendix-menu").checked = false;
                 document.getElementById("snb-subsection-menu").checked = false;
                 document.getElementById("snb-alternate-menu").checked = false;
                 document.getElementById("snb-rest-menu").checked = false;
                 document.getElementById("snb-opera-menu").checked = false;

                 document.getElementById("showss").disabled = true;
                 },

         selectTyp: function(typ)
                 {
                 document.getElementById('snb-deck1').setAttribute("selectedIndex", typ);
                 this.prefi.setIntPref("isClassic", typ);

                 document.getElementById("snb-document-menu").checked = (typ==0&&this.prefi.getBoolPref("document"))||lastIndex!=typ&&typ==0;
                 document.getElementById("snb-more-menu").checked = (typ==0&&this.prefi.getBoolPref("more"))||lastIndex!=typ&&typ==0;

                 lastSet = this.prefs.getCharPref("lastSet");
                 allID = snb_pref.allMenu.split(",");
                 for(var i=0; i<allID.length; i++)
                         {
                         wasLast = lastSet.indexOf(allID[i]) > 0;
                         cond1 = (typ==1&&this.prefi.getBoolPref(allID[i]));
                         cond2 = lastIndex!=typ&&typ==1&&wasLast;
                         var showThis = cond1||cond2;
                         document.getElementById("snb-"+allID[i]+"-menu").checked = showThis;
                         }

                 document.getElementById("snb-opera-menu").checked = (typ==2&&this.prefi.getBoolPref("opera"))||lastIndex!=typ&&typ==2;
                 },

         weiter: function(dstg)
                 {
                 document.getElementById("fehler").setAttribute("collapsed", true);
                 document.getElementById('rdg3').setAttribute("collapsed", true);
                 document.getElementById('snb_weiter').setAttribute("collapsed", true);
                 document.getElementById('snb_restore').setAttribute("collapsed", true);
                 document.getElementById('snb_back').setAttribute("collapsed", false);
                 document.getElementById('snb-deck1').setAttribute("selectedIndex", 3);

                 cb = document.getElementById("snb-deck1").getElementsByTagName("checkbox");
                 csArray = (dstg == 2)? snb_pref.curOpera.split(","):snb_pref.curRumpf.split(",");
                 for(i=0; i<cb.length; i++)
                         {
                         if(cb[i].id == "showss") continue;
                         if(cb[i].checked) csArray.push(cb[i].id);
                         if(cb[i].id == "snb-more-menu" && document.getElementById('rdg3').selectedIndex == 0
                         || (cb[i].id == "snb-subsection-menu" || cb[i].id == "snb-alternate-menu") && document.getElementById('rdg3').selectedIndex == 1
                         || cb[i].id == "snb-opera-menu" && document.getElementById('rdg3').selectedIndex == 2)
                                 if(csArray[csArray.length-1] != "separator") csArray.push("separator");
                         }
                 if(csArray[csArray.length-1] != "separator") csArray.push("separator");
                 csArray.push("snb-tag");
                 document.getElementById("snb-tb-curset").value = csArray.join(",");
                 },

         back: function()
                 {
                 document.getElementById('rdg3').setAttribute("collapsed", false);
                 document.getElementById('rdg3').selectedIndex = 0;
                 document.getElementById('snb_weiter').setAttribute("collapsed", false);
                 document.getElementById('snb_restore').setAttribute("collapsed", false);
                 document.getElementById('snb_back').setAttribute("collapsed", true);
                 document.getElementById('snb-deck1').setAttribute("selectedIndex", 0);
                 snb_pref.curRumpf = snb_pref.curRumpf.substr(0,73);
                 document.getElementById('snb-tb-curset').value = "";
                 },

         doOK: function()
                 {
                 if(document.documentElement.currentPane.id == "kb_snb_Cust")
                         {
                         if(document.getElementById('snb-deck1').selectedIndex != 3)
                                 {
                                 document.getElementById("fehler").setAttribute("collapsed", false);
                                 return false;
                                 }
                         this.prefi.setBoolPref("more", document.getElementById("snb-more-menu").checked);
                         this.prefi.setBoolPref("document", document.getElementById("snb-document-menu").checked);
                         this.prefi.setBoolPref("chapter", document.getElementById("snb-chapter-menu").checked);
                         this.prefi.setBoolPref("section", document.getElementById("snb-section-menu").checked);
                         this.prefi.setBoolPref("subsection", document.getElementById("snb-subsection-menu").checked);
                         this.prefi.setBoolPref("bookmark", document.getElementById("snb-bookmark-menu").checked);
                         this.prefi.setBoolPref("appendix", document.getElementById("snb-appendix-menu").checked);
                         this.prefi.setBoolPref("alternate", document.getElementById("snb-alternate-menu").checked);
                         this.prefi.setBoolPref("rest", document.getElementById("snb-rest-menu").checked);
                         this.prefi.setBoolPref("opera", document.getElementById("snb-opera-menu").checked);
                         }
                 if(document.getElementById('snb-tb-curset').value != "")
                         this.prefs.setCharPref("currentSet", document.getElementById('snb-tb-curset').value);
                 if(document.getElementById('rdg3').selectedIndex == 1)
                         this.prefs.setCharPref("lastSet", document.getElementById('snb-tb-curset').value);
                 return true;
                 },

         doCancel: function()
                 {
                 this.prefi.setIntPref("isClassic", altDIndex);
                 return true;
                 },

         show: function(zref)
                 {
                 try {snb_pref.ursprung.openUILinkIn(zref, 'tab');}
                 catch(e) {snb_pref.ursprung.kb_snb.promptService.alert(null, myBundle.getString("errorTitle"), e);}
                 },

         disableEv: function()
                 {
                 this.prefs.setBoolPref("supportEvents", false);
                 document.getElementById('snb-deck4_1').setAttribute("selectedIndex", 0);
                 },

         resetEv: function()
                 {
                 this.prefs.setCharPref("jvColor", "#3333FF");
                 this.prefs.setCharPref("daColor", "#3333FF");
                 this.prefs.setBoolPref("jvWarn", true);
                 this.prefs.setBoolPref("daWarn", true);
                 this.prefs.setIntPref("jvEn", 0);
                 },

         enDisAbleHl: function(einaus)
                 {
                 aus = einaus != 0;
                 document.getElementById('snb-jvs-al').disabled = aus;
                 document.getElementById('snb-jvs-cp').collapsed = aus;
                 document.getElementById('snb-jv-notify').disabled = aus;
                 aus = einaus == 4;
                 document.getElementById('snb-da-al').disabled = aus;
                 document.getElementById('snb-da-cp').collapsed = aus;
                 },

         enDisAbleEv: function(einaus)
                 {
                 this.prefs.setBoolPref('supportEvents', this.checked);
                 document.getElementById('snb_enmEv').disabled = einaus;
                 document.getElementById('snb-ev-al').disabled = einaus;
                 document.getElementById('snb-ev-cp').collapsed = einaus;
                 }


}